/*
 * generated by Xtext 2.27.0
 */
package tdt4250.ra.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;
import tdt4250.ra.Course;
import tdt4250.ra.Department;
import tdt4250.ra.Person;
import tdt4250.ra.RaPackage;
import tdt4250.ra.ResourceAllocation;
import tdt4250.ra.Role;
import tdt4250.ra.services.RaDSL2022GrammarAccess;

@SuppressWarnings("all")
public class RaDSL2022SemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private RaDSL2022GrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == RaPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case RaPackage.COURSE:
				sequence_Course(context, (Course) semanticObject); 
				return; 
			case RaPackage.DEPARTMENT:
				sequence_Department(context, (Department) semanticObject); 
				return; 
			case RaPackage.PERSON:
				sequence_Person(context, (Person) semanticObject); 
				return; 
			case RaPackage.RESOURCE_ALLOCATION:
				sequence_ResourceAllocation(context, (ResourceAllocation) semanticObject); 
				return; 
			case RaPackage.ROLE:
				sequence_Role(context, (Role) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * <pre>
	 * Contexts:
	 *     Course returns Course
	 *
	 * Constraint:
	 *     (name=EString (code=EString? (roles+=Role roles+=Role*)?)+)
	 * </pre>
	 */
	protected void sequence_Course(ISerializationContext context, Course semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Department returns Department
	 *
	 * Constraint:
	 *     (
	 *         name=EString 
	 *         shortName=EString? 
	 *         (staff+=Person staff+=Person*)? 
	 *         (courses+=Course courses+=Course*)? 
	 *         (resourceAllocations+=ResourceAllocation resourceAllocations+=ResourceAllocation*)?
	 *     )
	 * </pre>
	 */
	protected void sequence_Department(ISerializationContext context, Department semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Person returns Person
	 *
	 * Constraint:
	 *     name=EString
	 * </pre>
	 */
	protected void sequence_Person(ISerializationContext context, Person semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, RaPackage.Literals.PERSON__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RaPackage.Literals.PERSON__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getPersonAccess().getNameEStringParserRuleCall_2_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     ResourceAllocation returns ResourceAllocation
	 *
	 * Constraint:
	 *     (factor=EFloat? person=[Person|EString]? course=[Course|EString]? role=[Role|EString]?)
	 * </pre>
	 */
	protected void sequence_ResourceAllocation(ISerializationContext context, ResourceAllocation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Role returns Role
	 *
	 * Constraint:
	 *     (name=EString workload=EFloat?)
	 * </pre>
	 */
	protected void sequence_Role(ISerializationContext context, Role semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
